Bug 69123

Summary: [GTK] The process freezes when you right click on windowless Flash
Product: WebKit Reporter: Martin Robinson <mrobinson>
Component: WebKitGTKAssignee: Martin Robinson <mrobinson>
Status: RESOLVED FIXED    
Severity: Normal CC: alex, andersca, ariya.hidayat, cgarcia, gustavo.noronha, gustavo, pnormand, robert, xan.lopez
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on: 47545, 69139    
Bug Blocks:    
Attachments:
Description Flags
Patch
none
Patch using pluginInfo() to get plugin mime type
none
Patch
none
Fix build xan.lopez: review+

Description Martin Robinson 2011-09-29 21:12:26 PDT
Chromium and Qt had to work around this same issue. See: https://bugs.webkit.org/show_bug.cgi?id=47545
Comment 1 Martin Robinson 2011-09-29 22:40:49 PDT
Created attachment 109252 [details]
Patch
Comment 2 Carlos Garcia Campos 2011-09-30 01:38:16 PDT
Comment on attachment 109252 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=109252&action=review

> Source/WebKit2/Shared/Plugins/Netscape/x11/NetscapePluginModuleX11.cpp:177
> +    // FIXME: Calling getPluginInfo at this point causes a segmentation fault. Once
> +    // that's fixed this should be modified to check the mime type.

See bug https://bugs.webkit.org/show_bug.cgi?id=69139
Comment 3 Carlos Garcia Campos 2011-09-30 02:00:45 PDT
Comment on attachment 109252 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=109252&action=review

> Source/WebCore/ChangeLog:14
> +        (WebCore::PluginPackage::determineQuirks): Always activate the windowless
> +        Flash quirk if on x86_64 and X11.

I'm confused, the problem is with windowed or windowless plugins? Bug title says windowed.
Comment 4 Carlos Garcia Campos 2011-09-30 02:04:33 PDT
Created attachment 109268 [details]
Patch using pluginInfo() to get plugin mime type

It's martin's patch but using pluginInfo to get plugin mime type in determineQuirks(). It depends on bug https://bugs.webkit.org/show_bug.cgi?id=69139
Comment 5 Gustavo Noronha (kov) 2011-09-30 02:15:29 PDT
Comment on attachment 109268 [details]
Patch using pluginInfo() to get plugin mime type

Attachment 109268 [details] did not pass gtk-ews (gtk):
Output: http://queues.webkit.org/results/9888759
Comment 6 Martin Robinson 2011-10-27 18:22:44 PDT
Created attachment 112801 [details]
Patch
Comment 7 Martin Robinson 2011-10-27 18:23:40 PDT
I updated the patch to fix the bug title. Philippe, do you mind reviewing this one. We should really get this into the stable branch ASAP.
Comment 8 Collabora GTK+ EWS bot 2011-10-27 23:14:09 PDT
Comment on attachment 112801 [details]
Patch

Attachment 112801 [details] did not pass gtk-ews (gtk):
Output: http://queues.webkit.org/results/10238114
Comment 9 Martin Robinson 2011-10-28 00:26:56 PDT
Created attachment 112822 [details]
Fix build
Comment 10 Xan Lopez 2011-11-16 10:20:03 PST
Comment on attachment 112822 [details]
Fix build

View in context: https://bugs.webkit.org/attachment.cgi?id=112822&action=review

Looks good to me minus the nits.

> Source/WebKit2/ChangeLog:15
> +        events while in windowed mode.

I think you mean windowless here.

> Source/WebKit2/Shared/Plugins/Netscape/x11/NetscapePluginModuleX11.cpp:187
> +#endif

If this only affects some versions of the plugin shouldn't you check for that? Eg, if it's fixed in 11 or whatever, don't disable right click then.
Comment 11 Martin Robinson 2011-11-17 21:56:17 PST
(In reply to comment #10)
 
> > Source/WebKit2/Shared/Plugins/Netscape/x11/NetscapePluginModuleX11.cpp:187
> > +#endif
> 
> If this only affects some versions of the plugin shouldn't you check for that? Eg, if it's fixed in 11 or whatever, don't disable right click then.

From what I understand this only works in versions of Flash that are quite old now and contain security vulnerabilties. When a  new versions of Flash appear that fixes this, I think it makes sense to allow it, but at this point I'm not sure if those old versions of Flash are worth consideration.
Comment 12 Martin Robinson 2011-11-17 21:57:05 PST
(In reply to comment #11)

> > If this only affects some versions of the plugin shouldn't you check for that? Eg, if it's fixed in 11 or whatever, don't disable right click then.
> 
> From what I understand this only works in versions of Flash that are quite old now and contain security vulnerabilties. When a  new versions of Flash appear that fixes this, I think it makes sense to allow it, but at this point I'm not sure if those old versions of Flash are worth consideration.

I forgot to say that I'll land this now and, if you like, I can open a new bug addressing supporting right-click menus for older Flash versions.
Comment 13 Martin Robinson 2011-11-17 22:09:32 PST
Committed r100725: <http://trac.webkit.org/changeset/100725>
Comment 14 Martin Robinson 2011-11-17 22:10:05 PST
(In reply to comment #10)

> Source/WebKit2/ChangeLog:15
> > +        events while in windowed mode.
> 
> I think you mean windowless here.

Thanks for the review! Landed this with this fix.